<template>
  <div
    class="promo-detail flex-col h-screen"
    :class="{ flex: show, hidden: !show }"
  >
    <header class="bg-white flex p-3 justify-center items-center">
      <button
        class="w-1/12 flex items-center justify-center"
        @click="hideDetails"
      >
        <font-awesome-icon :icon="['fas', 'angle-left']" class="mr-1" />
      </button>
      <div class="w-11/12 text-center" v-html="promotion.Title"></div>
    </header>
    <main class="flex-1 overflow-y-auto promotion-detail__main">
      <div class="w-full h-[350px]">
        <img
          :src="promotion.ImagePathForDisplay"
          class="w-full h-full object-contain"
        />
      </div>
      <div class="description p-5">
        <div class="text-base">
          {{ $t("duration") }} : {{ promotion.DateRangeForDisplay }}
        </div>
        <div class="text-base">
          {{ $t("code") }} : {{ promotion.PromoCode }}
        </div>
        <div v-html="promotion.Content" class="promo-detail__content"></div>
      </div>
    </main>
    <template v-if="promotion.PromotionTypeId === 10">
      <footer
        v-if="validateLuckyWheelbutton(promotion)"
        class="promo-detail__footer mb-[50px]"
      >
        <el-button class="btn btn-apply-promotion" @click="onClickSpinNow"
        :id="`mobile_${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
          >{{ $t("Spin Now") }}
        </el-button>
      </footer>
    </template>
    <template v-else>
      <footer
        class="promo-detail__footer mb-[50px]"
        v-if="buttonApplyPromotionEnabled(promotion)"
      >
        <el-button
          class="btn btn-apply-promotion"
          @click="onApplyPromotion(promotion)"
          :disabled="isProcessing"
          :loading="isProcessing"
          :id="`mobile_${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
          >{{ $t("apply") }}</el-button
        >
      </footer>
    </template>
  </div>
</template>

<script setup lang="ts">
import { useRouter } from "vue-router";
import { Promotion } from "@/models/promotion/promotion";
import { ID } from "~~/utils/constants";

const router = useRouter();
const {
  buttonApplyPromotionEnabled,
  onApplyPromotion,
  isProcessing,
  validateLuckyWheelbutton,
  onClickSpinNow,
} = usePromotion();
defineProps({
  show: {
    type: Boolean,
    required: false,
    default: false,
  },
  promotion: {
    type: Object as PropType<Promotion>,
    required: true,
  },
});

const hideDetails = () => {
  router.push({
    path: "/promotion",
    query: {},
  });
};
</script>

<style scoped>
.promo-detail {
  position: fixed;
  width: 100%;
  height: 100%;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
  background: var(--background2);
  color: black;
  z-index: 3;
}

.promotion-detail__main::-webkit-scrollbar:vertical {
  width: 11px;
}

.promotion-detail__main::-webkit-scrollbar:horizontal {
  height: 11px;
}

.promotion-detail__main::-webkit-scrollbar-thumb {
  border-radius: 8px;
  border: 2px solid var(--background1); /* should match background, can't be transparent */
  background-color: rgba(0, 0, 0, 0.5);
}

.promo-detail__content {
  word-wrap: break-word;
}

.promo-detail__footer {
  width: 100%;
  height: 8vh;
  z-index: 3;
  background-color: var(--background1);
  -webkit-filter: drop-shadow(0 -1px 3px rgba(187, 193, 207, 0.4));
  filter: drop-shadow(0 -1px 3px rgba(187, 193, 207, 0.4));
  border-radius: 1.32rem 1.32rem 0 0;
  padding: 10px;
}

.btn-apply-promotion {
  width: 100%;
  height: 100%;
  color: var(--background1);
  background: linear-gradient(90deg, #62b3ff, #3d72fa);
  outline: none;
  border: none;
  border-radius: 0.5rem;
  font-weight: 700;
  font-size: 80%;
}
</style>
